/* SPDX-FileCopyrightText: © 2022 Decompollaborate */
/* SPDX-License-Identifier: MIT */

#ifndef RABBITIZER_OPERAND_TYPE_H
#define RABBITIZER_OPERAND_TYPE_H
#pragma once


typedef enum RabbitizerOperandType {
    RABBITIZER_OPERAND_TYPE_INVALID,

    RABBITIZER_OPERAND_TYPE_rs,
    RABBITIZER_OPERAND_TYPE_rt,
    RABBITIZER_OPERAND_TYPE_rd,
    RABBITIZER_OPERAND_TYPE_sa,
    RABBITIZER_OPERAND_TYPE_zero, // $zero
    // RABBITIZER_OPERAND_TYPE_function,
    RABBITIZER_OPERAND_TYPE_cop0d,
    RABBITIZER_OPERAND_TYPE_fs,
    RABBITIZER_OPERAND_TYPE_ft,
    RABBITIZER_OPERAND_TYPE_fd,
    RABBITIZER_OPERAND_TYPE_cop1cs, // Coprocessor 1 control fs
    RABBITIZER_OPERAND_TYPE_cop2t,
    RABBITIZER_OPERAND_TYPE_op,
    RABBITIZER_OPERAND_TYPE_code,
    RABBITIZER_OPERAND_TYPE_copraw,
    RABBITIZER_OPERAND_TYPE_LABEL,
    RABBITIZER_OPERAND_TYPE_IMM,
    // composed/aliased operands
    RABBITIZER_OPERAND_TYPE_IMM_base,

    /* rsp */
    RABBITIZER_OPERAND_TYPE_RSP_rs,
    RABBITIZER_OPERAND_TYPE_RSP_rt,
    RABBITIZER_OPERAND_TYPE_RSP_rd,
    RABBITIZER_OPERAND_TYPE_RSP_cop0d,
    RABBITIZER_OPERAND_TYPE_RSP_cop2t,
    RABBITIZER_OPERAND_TYPE_RSP_cop2cd, // Coprocessor 2 control rd
    RABBITIZER_OPERAND_TYPE_RSP_vs,
    RABBITIZER_OPERAND_TYPE_RSP_vt,
    RABBITIZER_OPERAND_TYPE_RSP_vd,
    // RABBITIZER_OPERAND_TYPE_RSP_elementhigh,
    // RABBITIZER_OPERAND_TYPE_RSP_elementlow,
    // RABBITIZER_OPERAND_TYPE_RSP_index,
    // RABBITIZER_OPERAND_TYPE_RSP_offset,
    // composed/aliased operands
    RABBITIZER_OPERAND_TYPE_RSP_vt_elementhigh,
    RABBITIZER_OPERAND_TYPE_RSP_vt_elementlow,
    RABBITIZER_OPERAND_TYPE_RSP_vd_de,
    RABBITIZER_OPERAND_TYPE_RSP_vs_index,
    RABBITIZER_OPERAND_TYPE_RSP_offset_rs,
    RABBITIZER_OPERAND_TYPE_RSP_IMM_base,
    /* rsp */

    /* R5900 */
    RABBITIZER_OPERAND_TYPE_R5900_I,
    RABBITIZER_OPERAND_TYPE_R5900_Q,
    RABBITIZER_OPERAND_TYPE_R5900_R,
    RABBITIZER_OPERAND_TYPE_R5900_ACC,
    RABBITIZER_OPERAND_TYPE_R5900_ACCxyzw,
    RABBITIZER_OPERAND_TYPE_R5900_vfs,
    RABBITIZER_OPERAND_TYPE_R5900_vft,
    RABBITIZER_OPERAND_TYPE_R5900_vfd,
    RABBITIZER_OPERAND_TYPE_R5900_vfsxyzw,
    RABBITIZER_OPERAND_TYPE_R5900_vftxyzw,
    RABBITIZER_OPERAND_TYPE_R5900_vfdxyzw,
    RABBITIZER_OPERAND_TYPE_R5900_vfsn,
    RABBITIZER_OPERAND_TYPE_R5900_vftn,
    RABBITIZER_OPERAND_TYPE_R5900_vfdn,
    RABBITIZER_OPERAND_TYPE_R5900_vfsl,
    RABBITIZER_OPERAND_TYPE_R5900_vftl,
    RABBITIZER_OPERAND_TYPE_R5900_vfdl,
    RABBITIZER_OPERAND_TYPE_R5900_vfsm,
    RABBITIZER_OPERAND_TYPE_R5900_vftm,
    RABBITIZER_OPERAND_TYPE_R5900_vfdm,
    RABBITIZER_OPERAND_TYPE_R5900_vis,
    RABBITIZER_OPERAND_TYPE_R5900_vit,
    RABBITIZER_OPERAND_TYPE_R5900_vid,
    RABBITIZER_OPERAND_TYPE_R5900_vis_predecr,
    RABBITIZER_OPERAND_TYPE_R5900_vit_predecr,
    RABBITIZER_OPERAND_TYPE_R5900_vid_predecr,
    RABBITIZER_OPERAND_TYPE_R5900_vis_postincr,
    RABBITIZER_OPERAND_TYPE_R5900_vit_postincr,
    RABBITIZER_OPERAND_TYPE_R5900_vid_postincr,
    RABBITIZER_OPERAND_TYPE_R5900_imm5,
    /* R5900 */

    RABBITIZER_OPERAND_TYPE_MAX
} RabbitizerOperandType;

#endif
